// ---------------------------------------------------------------------------
//
// frmMain(ftComputing50.PAS/DFM)                        Ulrich Mller 28.2.02
//                                                       Procida 400NT Delphi4
// Template fr Projekte mit FishFa50.DCU
// auf Basis von umFish20.DLL
//
// Der Modellbetrieb wird durch Klick auf den Button START gestartet
// die zugehrende Event-Procedure cmdActionClick steuert den Ablauf.
// Die Befehle fr den Modellbetrieb werden in der procedure Action
// untergebracht. ber den ENDE/HALT-Button wird das Beenden des Programms/
// Modellbetriebes gesteuert.
// FormCloseQuery verhindert das Programmende whrend des Modellbetriebs
// Der Programmstatus wird in lblStatus angezeigt
//
// ---------------------------------------------------------------------------

unit ftComputing50;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FishFa50;

type
  TfrmMain = class(TForm)
    cmdAction: TButton;
    cmdEnde: TButton;
    cboPortName: TComboBox;
    lblStatus: TLabel;
    procedure cmdEndeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Action();
    procedure cmdActionClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation
{$R *.DFM}

var
  ft: TFishFace;


procedure TfrmMain.Action();
// --- Routine fr den Modellbetrieb, kann weitere procedures aufrufen ---
begin
  repeat                   // --- Modellbetrieb in einer Endlosschleife

  until ft.Finish(0);      // --- Abbruch durch HALT-Button oder ESC-Taste
                           //     auch durch E-Eingang mglich (1-8(16))
                           //     kann gestrichen werden, wenn Modellbetrieb
                           //     nur 'geradeaus' (ohne Schleife)
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  ft := TFishFace.Create;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ft.Free;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
// --- Programmende sperren, wenn noch Modellbetrieb ------
begin
  if cmdEnde.Caption = '&HALT' then CanClose := false;
end;

procedure TfrmMain.cmdActionClick(Sender: TObject);
// --- Steuern des Modellbetriebes --------------------
begin
//ft.AnalogScan := true;       // --- Wenn auch EX/EY benutzt wird, aktivieren
//ft.Slave      := true;       // --- Zum Betrieb eines Extension Module
                               //     aktivieren
  if ft.OpenInterface(cboPortName.Text) = ftiFehler then begin
    MessageDlg('InterfaceProblem', mtInformation, [mbOK], 0);
    exit;
    end;
  cmdAction.Enabled := false;
  cmdEnde.Caption   := '&HALT';
  lblStatus.Caption := 'luft';
  cmdEnde.SetFocus;

  Action;

  ft.ClearMotors;
  ft.CloseInterface;
  cmdAction.Enabled := true;
  cmdEnde.Caption   := '&ENDE';
  lblStatus.Caption := 'START/ENDE';
end;

procedure TfrmMain.cmdEndeClick(Sender: TObject);
// --- Beenden des Modellbetriebs, wenn HALT-Button, sonst Programmende ---
begin
  if cmdEnde.Caption = '&HALT' then ft.NotHalt := true else Self.Close;
end;

end.
